// RUN-DISABLED: stablehlo-translate --deserialize %s.0_9_0.bc | stablehlo-opt -inline | stablehlo-translate --interpret
// RUN: diff <(stablehlo-translate --deserialize %s.0_9_0.bc | stablehlo-opt) <(stablehlo-opt %s)
// RUN: diff <(stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt) <(stablehlo-opt %s)

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0:3 = call @inputs() : () -> (tensor<9xf32>, tensor<9xf32>, tensor<9xf32>)
    %1 = call @expected() : () -> tensor<9xf32>
    %2 = call @regularized_incomplete_beta(%0#0, %0#1, %0#2) : (tensor<9xf32>, tensor<9xf32>, tensor<9xf32>) -> tensor<9xf32>
    %3 = stablehlo.custom_call @check.eq(%2, %1) : (tensor<9xf32>, tensor<9xf32>) -> tensor<i1>
    return %3 : tensor<i1>
  }
  func.func private @inputs() -> (tensor<9xf32>, tensor<9xf32>, tensor<9xf32>) {
    %0 = stablehlo.constant dense<[-1.600000e+00, -1.400000e+00, -1.000000e+00, 0.000000e+00, 1.000000e-01, 3.000000e-01, 1.000000e+00, 1.400000e+00, 1.600000e+00]> : tensor<9xf32>
    %1 = stablehlo.constant dense<[-1.600000e+00, 1.400000e+00, 1.000000e+00, 0.000000e+00, 2.000000e-01, 1.000000e-01, 1.000000e+00, 1.400000e+00, -1.600000e+00]> : tensor<9xf32>
    %2 = stablehlo.constant dense<[1.000000e+00, -1.000000e+00, 2.000000e+00, 1.000000e+00, 3.000000e-01, 3.000000e-01, -1.000000e+00, 2.400000e+00, 1.600000e+00]> : tensor<9xf32>
    return %0, %1, %2 : tensor<9xf32>, tensor<9xf32>, tensor<9xf32>
  }
  func.func private @expected() -> tensor<9xf32> {
    %0 = stablehlo.constant dense<[0x7FC00000, 0x7FC00000, 0x7FC00000, 0x7FC00000, 0.622842908, 0.194610357, 0x7FC00000, 0x7FC00000, 0x7FC00000]> : tensor<9xf32>
    return %0 : tensor<9xf32>
  }
  func.func private @regularized_incomplete_beta(%arg0: tensor<9xf32>, %arg1: tensor<9xf32>, %arg2: tensor<9xf32>) -> tensor<9xf32> {
    %0 = call @xla_fallback_regularized_incomplete_beta(%arg0, %arg1, %arg2) : (tensor<9xf32>, tensor<9xf32>, tensor<9xf32>) -> tensor<9xf32>
    return %0 : tensor<9xf32>
  }
  func.func private @or.54(%arg0: tensor<i1>, %arg1: tensor<i1>) -> tensor<i1> {
    %0 = stablehlo.or %arg0, %arg1 : tensor<i1>
    return %0 : tensor<i1>
  }
  func.func private @Betainc_body.58(%arg0: tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>> {
    %0 = stablehlo.get_tuple_element %arg0[1] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<i1>
    %1 = stablehlo.get_tuple_element %arg0[0] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<ui32>
    %2 = stablehlo.constant dense<1> : tensor<ui32>
    %3 = stablehlo.add %1, %2 : tensor<ui32>
    %4 = stablehlo.broadcast_in_dim %1, dims = [] : (tensor<ui32>) -> tensor<9xui32>
    %5 = stablehlo.constant dense<0> : tensor<ui32>
    %6 = stablehlo.constant dense<0> : tensor<9xui32>
    %7 = stablehlo.compare  EQ, %4, %6 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
    %8 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %9 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %10 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %11 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %12 = stablehlo.select %7, %9, %11 : tensor<9xi1>, tensor<9xf32>
    %13 = stablehlo.broadcast_in_dim %1, dims = [] : (tensor<ui32>) -> tensor<9xui32>
    %14 = stablehlo.constant dense<1> : tensor<ui32>
    %15 = stablehlo.constant dense<1> : tensor<9xui32>
    %16 = stablehlo.compare  EQ, %13, %15 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
    %17 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %18 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %19 = stablehlo.constant dense<2> : tensor<ui32>
    %20 = stablehlo.constant dense<2> : tensor<9xui32>
    %21 = stablehlo.remainder %13, %20 : tensor<9xui32>
    %22 = stablehlo.constant dense<0> : tensor<ui32>
    %23 = stablehlo.constant dense<0> : tensor<9xui32>
    %24 = stablehlo.compare  EQ, %21, %23 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
    %25 = stablehlo.get_tuple_element %arg0[5] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %26 = stablehlo.constant dense<1> : tensor<ui32>
    %27 = stablehlo.constant dense<1> : tensor<9xui32>
    %28 = stablehlo.subtract %13, %27 : tensor<9xui32>
    %29 = stablehlo.constant dense<2> : tensor<ui32>
    %30 = stablehlo.constant dense<2> : tensor<9xui32>
    %31 = stablehlo.divide %28, %30 : tensor<9xui32>
    %32 = stablehlo.convert %31 : (tensor<9xui32>) -> tensor<9xf32>
    %33 = stablehlo.add %25, %32 : tensor<9xf32>
    %34 = stablehlo.negate %33 : tensor<9xf32>
    %35 = stablehlo.get_tuple_element %arg0[6] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %36 = stablehlo.add %25, %35 : tensor<9xf32>
    %37 = stablehlo.add %36, %32 : tensor<9xf32>
    %38 = stablehlo.multiply %34, %37 : tensor<9xf32>
    %39 = stablehlo.get_tuple_element %arg0[7] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %40 = stablehlo.multiply %38, %39 : tensor<9xf32>
    %41 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
    %42 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
    %43 = stablehlo.multiply %42, %32 : tensor<9xf32>
    %44 = stablehlo.add %25, %43 : tensor<9xf32>
    %45 = stablehlo.multiply %42, %32 : tensor<9xf32>
    %46 = stablehlo.add %25, %45 : tensor<9xf32>
    %47 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %48 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %49 = stablehlo.add %46, %48 : tensor<9xf32>
    %50 = stablehlo.multiply %44, %49 : tensor<9xf32>
    %51 = stablehlo.divide %40, %50 : tensor<9xf32>
    %52 = stablehlo.subtract %35, %32 : tensor<9xf32>
    %53 = stablehlo.multiply %32, %52 : tensor<9xf32>
    %54 = stablehlo.multiply %53, %39 : tensor<9xf32>
    %55 = stablehlo.multiply %42, %32 : tensor<9xf32>
    %56 = stablehlo.add %25, %55 : tensor<9xf32>
    %57 = stablehlo.subtract %56, %48 : tensor<9xf32>
    %58 = stablehlo.multiply %42, %32 : tensor<9xf32>
    %59 = stablehlo.add %25, %58 : tensor<9xf32>
    %60 = stablehlo.multiply %57, %59 : tensor<9xf32>
    %61 = stablehlo.divide %54, %60 : tensor<9xf32>
    %62 = stablehlo.select %24, %51, %61 : tensor<9xi1>, tensor<9xf32>
    %63 = stablehlo.select %16, %18, %62 : tensor<9xi1>, tensor<9xf32>
    %64 = stablehlo.get_tuple_element %arg0[2] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %65 = stablehlo.divide %63, %64 : tensor<9xf32>
    %66 = stablehlo.add %12, %65 : tensor<9xf32>
    %67 = stablehlo.abs %66 : tensor<9xf32>
    %68 = stablehlo.constant dense<5.96046448E-8> : tensor<f32>
    %69 = stablehlo.constant dense<5.96046448E-8> : tensor<9xf32>
    %70 = stablehlo.compare  LT, %67, %69 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %71 = stablehlo.select %70, %69, %66 : tensor<9xi1>, tensor<9xf32>
    %72 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %73 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %74 = stablehlo.get_tuple_element %arg0[3] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %75 = stablehlo.multiply %63, %74 : tensor<9xf32>
    %76 = stablehlo.add %12, %75 : tensor<9xf32>
    %77 = stablehlo.abs %76 : tensor<9xf32>
    %78 = stablehlo.compare  LT, %77, %69 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %79 = stablehlo.select %78, %69, %76 : tensor<9xi1>, tensor<9xf32>
    %80 = stablehlo.divide %73, %79 : tensor<9xf32>
    %81 = stablehlo.multiply %71, %80 : tensor<9xf32>
    %82 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %83 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %84 = stablehlo.subtract %81, %83 : tensor<9xf32>
    %85 = stablehlo.abs %84 : tensor<9xf32>
    %86 = stablehlo.constant dense<5.96046448E-8> : tensor<f32>
    %87 = stablehlo.constant dense<5.96046448E-8> : tensor<9xf32>
    %88 = stablehlo.compare  GE, %85, %87 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %89 = stablehlo.constant dense<false> : tensor<i1>
    %90 = stablehlo.reduce(%88 init: %89) across dimensions = [0] : (tensor<9xi1>, tensor<i1>) -> tensor<i1>
     reducer(%arg1: tensor<i1>, %arg2: tensor<i1>)  {
      %94 = stablehlo.or %arg1, %arg2 : tensor<i1>
      stablehlo.return %94 : tensor<i1>
    }
    %91 = stablehlo.get_tuple_element %arg0[4] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %92 = stablehlo.multiply %91, %81 : tensor<9xf32>
    %93 = stablehlo.tuple %3, %90, %71, %80, %92, %25, %35, %39 {xla_shape = "(u32[], pred[], f32[9]{0}, f32[9]{0}, f32[9]{0}, /*index=5*/f32[9]{0}, f32[9]{0}, f32[9]{0})"} : tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>
    return %93 : tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>
  }
  func.func private @Betainc_condition.154(%arg0: tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<i1> {
    %0 = stablehlo.get_tuple_element %arg0[2] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %1 = stablehlo.get_tuple_element %arg0[3] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %2 = stablehlo.get_tuple_element %arg0[4] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %3 = stablehlo.get_tuple_element %arg0[5] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %4 = stablehlo.get_tuple_element %arg0[6] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %5 = stablehlo.get_tuple_element %arg0[7] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<9xf32>
    %6 = stablehlo.get_tuple_element %arg0[0] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<ui32>
    %7 = stablehlo.constant dense<200> : tensor<ui32>
    %8 = stablehlo.compare  LT, %6, %7 : (tensor<ui32>, tensor<ui32>) -> tensor<i1>
    %9 = stablehlo.get_tuple_element %arg0[1] : (tuple<tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>>) -> tensor<i1>
    %10 = stablehlo.and %8, %9 : tensor<i1>
    return %10 : tensor<i1>
  }
  func.func private @xla_fallback_regularized_incomplete_beta(%arg0: tensor<9xf32>, %arg1: tensor<9xf32>, %arg2: tensor<9xf32>) -> tensor<9xf32> {
    %0 = stablehlo.constant dense<1> : tensor<ui32>
    %1 = stablehlo.constant dense<true> : tensor<i1>
    %2 = stablehlo.constant dense<0> : tensor<ui32>
    %3 = stablehlo.constant dense<0> : tensor<9xui32>
    %4 = stablehlo.constant dense<0> : tensor<ui32>
    %5 = stablehlo.constant dense<0> : tensor<9xui32>
    %6 = stablehlo.compare  EQ, %3, %5 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
    %7 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %8 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %9 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %10 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %11 = stablehlo.select %6, %8, %10 : tensor<9xi1>, tensor<9xf32>
    %12 = stablehlo.abs %11 : tensor<9xf32>
    %13 = stablehlo.constant dense<5.96046448E-8> : tensor<f32>
    %14 = stablehlo.constant dense<5.96046448E-8> : tensor<9xf32>
    %15 = stablehlo.compare  LT, %12, %14 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %16 = stablehlo.select %15, %14, %11 : tensor<9xi1>, tensor<9xf32>
    %17 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %18 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %19 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %20 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %21 = stablehlo.add %arg0, %20 : tensor<9xf32>
    %22 = stablehlo.add %arg0, %arg1 : tensor<9xf32>
    %23 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
    %24 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
    %25 = stablehlo.add %22, %24 : tensor<9xf32>
    %26 = stablehlo.divide %21, %25 : tensor<9xf32>
    %27 = stablehlo.compare  LT, %arg2, %26 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %28 = stablehlo.select %27, %arg0, %arg1 : tensor<9xi1>, tensor<9xf32>
    %29 = stablehlo.select %27, %arg1, %arg0 : tensor<9xi1>, tensor<9xf32>
    %30 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %31 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %32 = stablehlo.subtract %31, %arg2 : tensor<9xf32>
    %33 = stablehlo.select %27, %arg2, %32 : tensor<9xi1>, tensor<9xf32>
    %34:8 = stablehlo.while(%iterArg = %0, %iterArg_0 = %1, %iterArg_1 = %16, %iterArg_2 = %18, %iterArg_3 = %16, %iterArg_4 = %28, %iterArg_5 = %29, %iterArg_6 = %33) : tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>
     cond {
      %463 = stablehlo.constant dense<200> : tensor<ui32>
      %464 = stablehlo.compare  LT, %iterArg, %463 : (tensor<ui32>, tensor<ui32>) -> tensor<i1>
      %465 = stablehlo.and %464, %iterArg_0 : tensor<i1>
      stablehlo.return %465 : tensor<i1>
    } do {
      %463 = stablehlo.constant dense<1> : tensor<ui32>
      %464 = stablehlo.add %iterArg, %463 : tensor<ui32>
      %465 = stablehlo.broadcast_in_dim %iterArg, dims = [] : (tensor<ui32>) -> tensor<9xui32>
      %466 = stablehlo.constant dense<0> : tensor<ui32>
      %467 = stablehlo.constant dense<0> : tensor<9xui32>
      %468 = stablehlo.compare  EQ, %465, %467 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
      %469 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
      %470 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
      %471 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
      %472 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
      %473 = stablehlo.select %468, %470, %472 : tensor<9xi1>, tensor<9xf32>
      %474 = stablehlo.broadcast_in_dim %iterArg, dims = [] : (tensor<ui32>) -> tensor<9xui32>
      %475 = stablehlo.constant dense<1> : tensor<ui32>
      %476 = stablehlo.constant dense<1> : tensor<9xui32>
      %477 = stablehlo.compare  EQ, %474, %476 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
      %478 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
      %479 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
      %480 = stablehlo.constant dense<2> : tensor<ui32>
      %481 = stablehlo.constant dense<2> : tensor<9xui32>
      %482 = stablehlo.remainder %474, %481 : tensor<9xui32>
      %483 = stablehlo.constant dense<0> : tensor<ui32>
      %484 = stablehlo.constant dense<0> : tensor<9xui32>
      %485 = stablehlo.compare  EQ, %482, %484 : (tensor<9xui32>, tensor<9xui32>) -> tensor<9xi1>
      %486 = stablehlo.constant dense<1> : tensor<ui32>
      %487 = stablehlo.constant dense<1> : tensor<9xui32>
      %488 = stablehlo.subtract %474, %487 : tensor<9xui32>
      %489 = stablehlo.constant dense<2> : tensor<ui32>
      %490 = stablehlo.constant dense<2> : tensor<9xui32>
      %491 = stablehlo.divide %488, %490 : tensor<9xui32>
      %492 = stablehlo.convert %491 : (tensor<9xui32>) -> tensor<9xf32>
      %493 = stablehlo.add %iterArg_4, %492 : tensor<9xf32>
      %494 = stablehlo.negate %493 : tensor<9xf32>
      %495 = stablehlo.add %iterArg_4, %iterArg_5 : tensor<9xf32>
      %496 = stablehlo.add %495, %492 : tensor<9xf32>
      %497 = stablehlo.multiply %494, %496 : tensor<9xf32>
      %498 = stablehlo.multiply %497, %iterArg_6 : tensor<9xf32>
      %499 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
      %500 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
      %501 = stablehlo.multiply %500, %492 : tensor<9xf32>
      %502 = stablehlo.add %iterArg_4, %501 : tensor<9xf32>
      %503 = stablehlo.multiply %500, %492 : tensor<9xf32>
      %504 = stablehlo.add %iterArg_4, %503 : tensor<9xf32>
      %505 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
      %506 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
      %507 = stablehlo.add %504, %506 : tensor<9xf32>
      %508 = stablehlo.multiply %502, %507 : tensor<9xf32>
      %509 = stablehlo.divide %498, %508 : tensor<9xf32>
      %510 = stablehlo.subtract %iterArg_5, %492 : tensor<9xf32>
      %511 = stablehlo.multiply %492, %510 : tensor<9xf32>
      %512 = stablehlo.multiply %511, %iterArg_6 : tensor<9xf32>
      %513 = stablehlo.multiply %500, %492 : tensor<9xf32>
      %514 = stablehlo.add %iterArg_4, %513 : tensor<9xf32>
      %515 = stablehlo.subtract %514, %506 : tensor<9xf32>
      %516 = stablehlo.multiply %500, %492 : tensor<9xf32>
      %517 = stablehlo.add %iterArg_4, %516 : tensor<9xf32>
      %518 = stablehlo.multiply %515, %517 : tensor<9xf32>
      %519 = stablehlo.divide %512, %518 : tensor<9xf32>
      %520 = stablehlo.select %485, %509, %519 : tensor<9xi1>, tensor<9xf32>
      %521 = stablehlo.select %477, %479, %520 : tensor<9xi1>, tensor<9xf32>
      %522 = stablehlo.divide %521, %iterArg_1 : tensor<9xf32>
      %523 = stablehlo.add %473, %522 : tensor<9xf32>
      %524 = stablehlo.abs %523 : tensor<9xf32>
      %525 = stablehlo.constant dense<5.96046448E-8> : tensor<f32>
      %526 = stablehlo.constant dense<5.96046448E-8> : tensor<9xf32>
      %527 = stablehlo.compare  LT, %524, %526 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
      %528 = stablehlo.select %527, %526, %523 : tensor<9xi1>, tensor<9xf32>
      %529 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
      %530 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
      %531 = stablehlo.multiply %521, %iterArg_2 : tensor<9xf32>
      %532 = stablehlo.add %473, %531 : tensor<9xf32>
      %533 = stablehlo.abs %532 : tensor<9xf32>
      %534 = stablehlo.compare  LT, %533, %526 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
      %535 = stablehlo.select %534, %526, %532 : tensor<9xi1>, tensor<9xf32>
      %536 = stablehlo.divide %530, %535 : tensor<9xf32>
      %537 = stablehlo.multiply %528, %536 : tensor<9xf32>
      %538 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
      %539 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
      %540 = stablehlo.subtract %537, %539 : tensor<9xf32>
      %541 = stablehlo.abs %540 : tensor<9xf32>
      %542 = stablehlo.constant dense<5.96046448E-8> : tensor<f32>
      %543 = stablehlo.constant dense<5.96046448E-8> : tensor<9xf32>
      %544 = stablehlo.compare  GE, %541, %543 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
      %545 = stablehlo.constant dense<false> : tensor<i1>
      %546 = stablehlo.reduce(%544 init: %545) across dimensions = [0] : (tensor<9xi1>, tensor<i1>) -> tensor<i1>
       reducer(%arg3: tensor<i1>, %arg4: tensor<i1>)  {
        %548 = stablehlo.or %arg3, %arg4 : tensor<i1>
        stablehlo.return %548 : tensor<i1>
      }
      %547 = stablehlo.multiply %iterArg_3, %537 : tensor<9xf32>
      stablehlo.return %464, %546, %528, %536, %547, %iterArg_4, %iterArg_5, %iterArg_6 : tensor<ui32>, tensor<i1>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>, tensor<9xf32>
    }
    %35 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %36 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %37 = stablehlo.compare  LE, %arg0, %36 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %38 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %39 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %40 = stablehlo.compare  LE, %arg1, %39 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %41 = stablehlo.or %37, %40 : tensor<9xi1>
    %42 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %43 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %44 = stablehlo.compare  LT, %arg2, %43 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %45 = stablehlo.or %41, %44 : tensor<9xi1>
    %46 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %47 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %48 = stablehlo.compare  GT, %arg2, %47 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %49 = stablehlo.or %45, %48 : tensor<9xi1>
    %50 = stablehlo.constant dense<0x7FC00000> : tensor<f32>
    %51 = stablehlo.constant dense<0x7FC00000> : tensor<9xf32>
    %52 = stablehlo.log %33 : tensor<9xf32>
    %53 = stablehlo.multiply %52, %28 : tensor<9xf32>
    %54 = stablehlo.negate %33 : tensor<9xf32>
    %55 = stablehlo.log_plus_one %54 : tensor<9xf32>
    %56 = stablehlo.multiply %55, %29 : tensor<9xf32>
    %57 = stablehlo.add %53, %56 : tensor<9xf32>
    %58 = stablehlo.abs %28 : tensor<9xf32>
    %59 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %60 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %61 = stablehlo.compare  EQ, %58, %60 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %62 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %63 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %64 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %65 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %66 = stablehlo.compare  LT, %28, %65 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %67 = stablehlo.constant dense<3.14159274> : tensor<f32>
    %68 = stablehlo.constant dense<3.14159274> : tensor<9xf32>
    %69 = stablehlo.abs %28 : tensor<9xf32>
    %70 = stablehlo.floor %69 : tensor<9xf32>
    %71 = stablehlo.subtract %69, %70 : tensor<9xf32>
    %72 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %73 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %74 = stablehlo.compare  GT, %71, %73 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %75 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %76 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %77 = stablehlo.subtract %76, %71 : tensor<9xf32>
    %78 = stablehlo.select %74, %77, %71 : tensor<9xi1>, tensor<9xf32>
    %79 = stablehlo.multiply %68, %78 : tensor<9xf32>
    %80 = stablehlo.sine %79 : tensor<9xf32>
    %81 = stablehlo.log %80 : tensor<9xf32>
    %82 = stablehlo.is_finite %81 : (tensor<9xf32>) -> tensor<9xi1>
    %83 = stablehlo.constant dense<1.14472985> : tensor<f32>
    %84 = stablehlo.constant dense<1.14472985> : tensor<9xf32>
    %85 = stablehlo.subtract %84, %81 : tensor<9xf32>
    %86 = stablehlo.constant dense<0.918938517> : tensor<f32>
    %87 = stablehlo.constant dense<0.918938517> : tensor<9xf32>
    %88 = stablehlo.negate %28 : tensor<9xf32>
    %89 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %90 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %91 = stablehlo.subtract %28, %90 : tensor<9xf32>
    %92 = stablehlo.select %66, %88, %91 : tensor<9xi1>, tensor<9xf32>
    %93 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %94 = stablehlo.add %92, %93 : tensor<9xf32>
    %95 = stablehlo.constant dense<7.500000e+00> : tensor<f32>
    %96 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %97 = stablehlo.add %96, %92 : tensor<9xf32>
    %98 = stablehlo.constant dense<2.01490307> : tensor<f32>
    %99 = stablehlo.constant dense<2.01490307> : tensor<9xf32>
    %100 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %101 = stablehlo.divide %92, %100 : tensor<9xf32>
    %102 = stablehlo.log_plus_one %101 : tensor<9xf32>
    %103 = stablehlo.add %99, %102 : tensor<9xf32>
    %104 = stablehlo.divide %97, %103 : tensor<9xf32>
    %105 = stablehlo.subtract %94, %104 : tensor<9xf32>
    %106 = stablehlo.multiply %105, %103 : tensor<9xf32>
    %107 = stablehlo.add %87, %106 : tensor<9xf32>
    %108 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %109 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %110 = stablehlo.constant dense<676.520386> : tensor<f32>
    %111 = stablehlo.constant dense<676.520386> : tensor<9xf32>
    %112 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %113 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %114 = stablehlo.add %92, %113 : tensor<9xf32>
    %115 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %116 = stablehlo.add %114, %115 : tensor<9xf32>
    %117 = stablehlo.divide %111, %116 : tensor<9xf32>
    %118 = stablehlo.add %109, %117 : tensor<9xf32>
    %119 = stablehlo.constant dense<-1259.13916> : tensor<f32>
    %120 = stablehlo.constant dense<-1259.13916> : tensor<9xf32>
    %121 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %122 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %123 = stablehlo.add %92, %122 : tensor<9xf32>
    %124 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %125 = stablehlo.add %123, %124 : tensor<9xf32>
    %126 = stablehlo.divide %120, %125 : tensor<9xf32>
    %127 = stablehlo.add %118, %126 : tensor<9xf32>
    %128 = stablehlo.constant dense<771.323425> : tensor<f32>
    %129 = stablehlo.constant dense<771.323425> : tensor<9xf32>
    %130 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
    %131 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
    %132 = stablehlo.add %92, %131 : tensor<9xf32>
    %133 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %134 = stablehlo.add %132, %133 : tensor<9xf32>
    %135 = stablehlo.divide %129, %134 : tensor<9xf32>
    %136 = stablehlo.add %127, %135 : tensor<9xf32>
    %137 = stablehlo.constant dense<-176.615036> : tensor<f32>
    %138 = stablehlo.constant dense<-176.615036> : tensor<9xf32>
    %139 = stablehlo.constant dense<3.000000e+00> : tensor<f32>
    %140 = stablehlo.constant dense<3.000000e+00> : tensor<9xf32>
    %141 = stablehlo.add %92, %140 : tensor<9xf32>
    %142 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %143 = stablehlo.add %141, %142 : tensor<9xf32>
    %144 = stablehlo.divide %138, %143 : tensor<9xf32>
    %145 = stablehlo.add %136, %144 : tensor<9xf32>
    %146 = stablehlo.constant dense<12.5073433> : tensor<f32>
    %147 = stablehlo.constant dense<12.5073433> : tensor<9xf32>
    %148 = stablehlo.constant dense<4.000000e+00> : tensor<f32>
    %149 = stablehlo.constant dense<4.000000e+00> : tensor<9xf32>
    %150 = stablehlo.add %92, %149 : tensor<9xf32>
    %151 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %152 = stablehlo.add %150, %151 : tensor<9xf32>
    %153 = stablehlo.divide %147, %152 : tensor<9xf32>
    %154 = stablehlo.add %145, %153 : tensor<9xf32>
    %155 = stablehlo.constant dense<-0.138571098> : tensor<f32>
    %156 = stablehlo.constant dense<-0.138571098> : tensor<9xf32>
    %157 = stablehlo.constant dense<5.000000e+00> : tensor<f32>
    %158 = stablehlo.constant dense<5.000000e+00> : tensor<9xf32>
    %159 = stablehlo.add %92, %158 : tensor<9xf32>
    %160 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %161 = stablehlo.add %159, %160 : tensor<9xf32>
    %162 = stablehlo.divide %156, %161 : tensor<9xf32>
    %163 = stablehlo.add %154, %162 : tensor<9xf32>
    %164 = stablehlo.constant dense<9.98436917E-6> : tensor<f32>
    %165 = stablehlo.constant dense<9.98436917E-6> : tensor<9xf32>
    %166 = stablehlo.constant dense<6.000000e+00> : tensor<f32>
    %167 = stablehlo.constant dense<6.000000e+00> : tensor<9xf32>
    %168 = stablehlo.add %92, %167 : tensor<9xf32>
    %169 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %170 = stablehlo.add %168, %169 : tensor<9xf32>
    %171 = stablehlo.divide %165, %170 : tensor<9xf32>
    %172 = stablehlo.add %163, %171 : tensor<9xf32>
    %173 = stablehlo.constant dense<1.50563267E-7> : tensor<f32>
    %174 = stablehlo.constant dense<1.50563267E-7> : tensor<9xf32>
    %175 = stablehlo.constant dense<7.000000e+00> : tensor<f32>
    %176 = stablehlo.constant dense<7.000000e+00> : tensor<9xf32>
    %177 = stablehlo.add %92, %176 : tensor<9xf32>
    %178 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %179 = stablehlo.add %177, %178 : tensor<9xf32>
    %180 = stablehlo.divide %174, %179 : tensor<9xf32>
    %181 = stablehlo.add %172, %180 : tensor<9xf32>
    %182 = stablehlo.log %181 : tensor<9xf32>
    %183 = stablehlo.add %107, %182 : tensor<9xf32>
    %184 = stablehlo.subtract %85, %183 : tensor<9xf32>
    %185 = stablehlo.negate %81 : tensor<9xf32>
    %186 = stablehlo.select %82, %184, %185 : tensor<9xi1>, tensor<9xf32>
    %187 = stablehlo.select %66, %186, %183 : tensor<9xi1>, tensor<9xf32>
    %188 = stablehlo.select %61, %63, %187 : tensor<9xi1>, tensor<9xf32>
    %189 = stablehlo.abs %29 : tensor<9xf32>
    %190 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %191 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %192 = stablehlo.compare  EQ, %189, %191 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %193 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %194 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %195 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %196 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %197 = stablehlo.compare  LT, %29, %196 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %198 = stablehlo.constant dense<3.14159274> : tensor<f32>
    %199 = stablehlo.constant dense<3.14159274> : tensor<9xf32>
    %200 = stablehlo.abs %29 : tensor<9xf32>
    %201 = stablehlo.floor %200 : tensor<9xf32>
    %202 = stablehlo.subtract %200, %201 : tensor<9xf32>
    %203 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %204 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %205 = stablehlo.compare  GT, %202, %204 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %206 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %207 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %208 = stablehlo.subtract %207, %202 : tensor<9xf32>
    %209 = stablehlo.select %205, %208, %202 : tensor<9xi1>, tensor<9xf32>
    %210 = stablehlo.multiply %199, %209 : tensor<9xf32>
    %211 = stablehlo.sine %210 : tensor<9xf32>
    %212 = stablehlo.log %211 : tensor<9xf32>
    %213 = stablehlo.is_finite %212 : (tensor<9xf32>) -> tensor<9xi1>
    %214 = stablehlo.constant dense<1.14472985> : tensor<f32>
    %215 = stablehlo.constant dense<1.14472985> : tensor<9xf32>
    %216 = stablehlo.subtract %215, %212 : tensor<9xf32>
    %217 = stablehlo.constant dense<0.918938517> : tensor<f32>
    %218 = stablehlo.constant dense<0.918938517> : tensor<9xf32>
    %219 = stablehlo.negate %29 : tensor<9xf32>
    %220 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %221 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %222 = stablehlo.subtract %29, %221 : tensor<9xf32>
    %223 = stablehlo.select %197, %219, %222 : tensor<9xi1>, tensor<9xf32>
    %224 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %225 = stablehlo.add %223, %224 : tensor<9xf32>
    %226 = stablehlo.constant dense<7.500000e+00> : tensor<f32>
    %227 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %228 = stablehlo.add %227, %223 : tensor<9xf32>
    %229 = stablehlo.constant dense<2.01490307> : tensor<f32>
    %230 = stablehlo.constant dense<2.01490307> : tensor<9xf32>
    %231 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %232 = stablehlo.divide %223, %231 : tensor<9xf32>
    %233 = stablehlo.log_plus_one %232 : tensor<9xf32>
    %234 = stablehlo.add %230, %233 : tensor<9xf32>
    %235 = stablehlo.divide %228, %234 : tensor<9xf32>
    %236 = stablehlo.subtract %225, %235 : tensor<9xf32>
    %237 = stablehlo.multiply %236, %234 : tensor<9xf32>
    %238 = stablehlo.add %218, %237 : tensor<9xf32>
    %239 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %240 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %241 = stablehlo.constant dense<676.520386> : tensor<f32>
    %242 = stablehlo.constant dense<676.520386> : tensor<9xf32>
    %243 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %244 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %245 = stablehlo.add %223, %244 : tensor<9xf32>
    %246 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %247 = stablehlo.add %245, %246 : tensor<9xf32>
    %248 = stablehlo.divide %242, %247 : tensor<9xf32>
    %249 = stablehlo.add %240, %248 : tensor<9xf32>
    %250 = stablehlo.constant dense<-1259.13916> : tensor<f32>
    %251 = stablehlo.constant dense<-1259.13916> : tensor<9xf32>
    %252 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %253 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %254 = stablehlo.add %223, %253 : tensor<9xf32>
    %255 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %256 = stablehlo.add %254, %255 : tensor<9xf32>
    %257 = stablehlo.divide %251, %256 : tensor<9xf32>
    %258 = stablehlo.add %249, %257 : tensor<9xf32>
    %259 = stablehlo.constant dense<771.323425> : tensor<f32>
    %260 = stablehlo.constant dense<771.323425> : tensor<9xf32>
    %261 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
    %262 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
    %263 = stablehlo.add %223, %262 : tensor<9xf32>
    %264 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %265 = stablehlo.add %263, %264 : tensor<9xf32>
    %266 = stablehlo.divide %260, %265 : tensor<9xf32>
    %267 = stablehlo.add %258, %266 : tensor<9xf32>
    %268 = stablehlo.constant dense<-176.615036> : tensor<f32>
    %269 = stablehlo.constant dense<-176.615036> : tensor<9xf32>
    %270 = stablehlo.constant dense<3.000000e+00> : tensor<f32>
    %271 = stablehlo.constant dense<3.000000e+00> : tensor<9xf32>
    %272 = stablehlo.add %223, %271 : tensor<9xf32>
    %273 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %274 = stablehlo.add %272, %273 : tensor<9xf32>
    %275 = stablehlo.divide %269, %274 : tensor<9xf32>
    %276 = stablehlo.add %267, %275 : tensor<9xf32>
    %277 = stablehlo.constant dense<12.5073433> : tensor<f32>
    %278 = stablehlo.constant dense<12.5073433> : tensor<9xf32>
    %279 = stablehlo.constant dense<4.000000e+00> : tensor<f32>
    %280 = stablehlo.constant dense<4.000000e+00> : tensor<9xf32>
    %281 = stablehlo.add %223, %280 : tensor<9xf32>
    %282 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %283 = stablehlo.add %281, %282 : tensor<9xf32>
    %284 = stablehlo.divide %278, %283 : tensor<9xf32>
    %285 = stablehlo.add %276, %284 : tensor<9xf32>
    %286 = stablehlo.constant dense<-0.138571098> : tensor<f32>
    %287 = stablehlo.constant dense<-0.138571098> : tensor<9xf32>
    %288 = stablehlo.constant dense<5.000000e+00> : tensor<f32>
    %289 = stablehlo.constant dense<5.000000e+00> : tensor<9xf32>
    %290 = stablehlo.add %223, %289 : tensor<9xf32>
    %291 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %292 = stablehlo.add %290, %291 : tensor<9xf32>
    %293 = stablehlo.divide %287, %292 : tensor<9xf32>
    %294 = stablehlo.add %285, %293 : tensor<9xf32>
    %295 = stablehlo.constant dense<9.98436917E-6> : tensor<f32>
    %296 = stablehlo.constant dense<9.98436917E-6> : tensor<9xf32>
    %297 = stablehlo.constant dense<6.000000e+00> : tensor<f32>
    %298 = stablehlo.constant dense<6.000000e+00> : tensor<9xf32>
    %299 = stablehlo.add %223, %298 : tensor<9xf32>
    %300 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %301 = stablehlo.add %299, %300 : tensor<9xf32>
    %302 = stablehlo.divide %296, %301 : tensor<9xf32>
    %303 = stablehlo.add %294, %302 : tensor<9xf32>
    %304 = stablehlo.constant dense<1.50563267E-7> : tensor<f32>
    %305 = stablehlo.constant dense<1.50563267E-7> : tensor<9xf32>
    %306 = stablehlo.constant dense<7.000000e+00> : tensor<f32>
    %307 = stablehlo.constant dense<7.000000e+00> : tensor<9xf32>
    %308 = stablehlo.add %223, %307 : tensor<9xf32>
    %309 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %310 = stablehlo.add %308, %309 : tensor<9xf32>
    %311 = stablehlo.divide %305, %310 : tensor<9xf32>
    %312 = stablehlo.add %303, %311 : tensor<9xf32>
    %313 = stablehlo.log %312 : tensor<9xf32>
    %314 = stablehlo.add %238, %313 : tensor<9xf32>
    %315 = stablehlo.subtract %216, %314 : tensor<9xf32>
    %316 = stablehlo.negate %212 : tensor<9xf32>
    %317 = stablehlo.select %213, %315, %316 : tensor<9xi1>, tensor<9xf32>
    %318 = stablehlo.select %197, %317, %314 : tensor<9xi1>, tensor<9xf32>
    %319 = stablehlo.select %192, %194, %318 : tensor<9xi1>, tensor<9xf32>
    %320 = stablehlo.add %188, %319 : tensor<9xf32>
    %321 = stablehlo.add %28, %29 : tensor<9xf32>
    %322 = stablehlo.abs %321 : tensor<9xf32>
    %323 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %324 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %325 = stablehlo.compare  EQ, %322, %324 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %326 = stablehlo.constant dense<0x7F800000> : tensor<f32>
    %327 = stablehlo.constant dense<0x7F800000> : tensor<9xf32>
    %328 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %329 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %330 = stablehlo.compare  LT, %321, %329 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %331 = stablehlo.constant dense<3.14159274> : tensor<f32>
    %332 = stablehlo.constant dense<3.14159274> : tensor<9xf32>
    %333 = stablehlo.abs %321 : tensor<9xf32>
    %334 = stablehlo.floor %333 : tensor<9xf32>
    %335 = stablehlo.subtract %333, %334 : tensor<9xf32>
    %336 = stablehlo.constant dense<5.000000e-01> : tensor<f32>
    %337 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %338 = stablehlo.compare  GT, %335, %337 : (tensor<9xf32>, tensor<9xf32>) -> tensor<9xi1>
    %339 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %340 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %341 = stablehlo.subtract %340, %335 : tensor<9xf32>
    %342 = stablehlo.select %338, %341, %335 : tensor<9xi1>, tensor<9xf32>
    %343 = stablehlo.multiply %332, %342 : tensor<9xf32>
    %344 = stablehlo.sine %343 : tensor<9xf32>
    %345 = stablehlo.log %344 : tensor<9xf32>
    %346 = stablehlo.is_finite %345 : (tensor<9xf32>) -> tensor<9xi1>
    %347 = stablehlo.constant dense<1.14472985> : tensor<f32>
    %348 = stablehlo.constant dense<1.14472985> : tensor<9xf32>
    %349 = stablehlo.subtract %348, %345 : tensor<9xf32>
    %350 = stablehlo.constant dense<0.918938517> : tensor<f32>
    %351 = stablehlo.constant dense<0.918938517> : tensor<9xf32>
    %352 = stablehlo.negate %321 : tensor<9xf32>
    %353 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %354 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %355 = stablehlo.subtract %321, %354 : tensor<9xf32>
    %356 = stablehlo.select %330, %352, %355 : tensor<9xi1>, tensor<9xf32>
    %357 = stablehlo.constant dense<5.000000e-01> : tensor<9xf32>
    %358 = stablehlo.add %356, %357 : tensor<9xf32>
    %359 = stablehlo.constant dense<7.500000e+00> : tensor<f32>
    %360 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %361 = stablehlo.add %360, %356 : tensor<9xf32>
    %362 = stablehlo.constant dense<2.01490307> : tensor<f32>
    %363 = stablehlo.constant dense<2.01490307> : tensor<9xf32>
    %364 = stablehlo.constant dense<7.500000e+00> : tensor<9xf32>
    %365 = stablehlo.divide %356, %364 : tensor<9xf32>
    %366 = stablehlo.log_plus_one %365 : tensor<9xf32>
    %367 = stablehlo.add %363, %366 : tensor<9xf32>
    %368 = stablehlo.divide %361, %367 : tensor<9xf32>
    %369 = stablehlo.subtract %358, %368 : tensor<9xf32>
    %370 = stablehlo.multiply %369, %367 : tensor<9xf32>
    %371 = stablehlo.add %351, %370 : tensor<9xf32>
    %372 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %373 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %374 = stablehlo.constant dense<676.520386> : tensor<f32>
    %375 = stablehlo.constant dense<676.520386> : tensor<9xf32>
    %376 = stablehlo.constant dense<0.000000e+00> : tensor<f32>
    %377 = stablehlo.constant dense<0.000000e+00> : tensor<9xf32>
    %378 = stablehlo.add %356, %377 : tensor<9xf32>
    %379 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %380 = stablehlo.add %378, %379 : tensor<9xf32>
    %381 = stablehlo.divide %375, %380 : tensor<9xf32>
    %382 = stablehlo.add %373, %381 : tensor<9xf32>
    %383 = stablehlo.constant dense<-1259.13916> : tensor<f32>
    %384 = stablehlo.constant dense<-1259.13916> : tensor<9xf32>
    %385 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %386 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %387 = stablehlo.add %356, %386 : tensor<9xf32>
    %388 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %389 = stablehlo.add %387, %388 : tensor<9xf32>
    %390 = stablehlo.divide %384, %389 : tensor<9xf32>
    %391 = stablehlo.add %382, %390 : tensor<9xf32>
    %392 = stablehlo.constant dense<771.323425> : tensor<f32>
    %393 = stablehlo.constant dense<771.323425> : tensor<9xf32>
    %394 = stablehlo.constant dense<2.000000e+00> : tensor<f32>
    %395 = stablehlo.constant dense<2.000000e+00> : tensor<9xf32>
    %396 = stablehlo.add %356, %395 : tensor<9xf32>
    %397 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %398 = stablehlo.add %396, %397 : tensor<9xf32>
    %399 = stablehlo.divide %393, %398 : tensor<9xf32>
    %400 = stablehlo.add %391, %399 : tensor<9xf32>
    %401 = stablehlo.constant dense<-176.615036> : tensor<f32>
    %402 = stablehlo.constant dense<-176.615036> : tensor<9xf32>
    %403 = stablehlo.constant dense<3.000000e+00> : tensor<f32>
    %404 = stablehlo.constant dense<3.000000e+00> : tensor<9xf32>
    %405 = stablehlo.add %356, %404 : tensor<9xf32>
    %406 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %407 = stablehlo.add %405, %406 : tensor<9xf32>
    %408 = stablehlo.divide %402, %407 : tensor<9xf32>
    %409 = stablehlo.add %400, %408 : tensor<9xf32>
    %410 = stablehlo.constant dense<12.5073433> : tensor<f32>
    %411 = stablehlo.constant dense<12.5073433> : tensor<9xf32>
    %412 = stablehlo.constant dense<4.000000e+00> : tensor<f32>
    %413 = stablehlo.constant dense<4.000000e+00> : tensor<9xf32>
    %414 = stablehlo.add %356, %413 : tensor<9xf32>
    %415 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %416 = stablehlo.add %414, %415 : tensor<9xf32>
    %417 = stablehlo.divide %411, %416 : tensor<9xf32>
    %418 = stablehlo.add %409, %417 : tensor<9xf32>
    %419 = stablehlo.constant dense<-0.138571098> : tensor<f32>
    %420 = stablehlo.constant dense<-0.138571098> : tensor<9xf32>
    %421 = stablehlo.constant dense<5.000000e+00> : tensor<f32>
    %422 = stablehlo.constant dense<5.000000e+00> : tensor<9xf32>
    %423 = stablehlo.add %356, %422 : tensor<9xf32>
    %424 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %425 = stablehlo.add %423, %424 : tensor<9xf32>
    %426 = stablehlo.divide %420, %425 : tensor<9xf32>
    %427 = stablehlo.add %418, %426 : tensor<9xf32>
    %428 = stablehlo.constant dense<9.98436917E-6> : tensor<f32>
    %429 = stablehlo.constant dense<9.98436917E-6> : tensor<9xf32>
    %430 = stablehlo.constant dense<6.000000e+00> : tensor<f32>
    %431 = stablehlo.constant dense<6.000000e+00> : tensor<9xf32>
    %432 = stablehlo.add %356, %431 : tensor<9xf32>
    %433 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %434 = stablehlo.add %432, %433 : tensor<9xf32>
    %435 = stablehlo.divide %429, %434 : tensor<9xf32>
    %436 = stablehlo.add %427, %435 : tensor<9xf32>
    %437 = stablehlo.constant dense<1.50563267E-7> : tensor<f32>
    %438 = stablehlo.constant dense<1.50563267E-7> : tensor<9xf32>
    %439 = stablehlo.constant dense<7.000000e+00> : tensor<f32>
    %440 = stablehlo.constant dense<7.000000e+00> : tensor<9xf32>
    %441 = stablehlo.add %356, %440 : tensor<9xf32>
    %442 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %443 = stablehlo.add %441, %442 : tensor<9xf32>
    %444 = stablehlo.divide %438, %443 : tensor<9xf32>
    %445 = stablehlo.add %436, %444 : tensor<9xf32>
    %446 = stablehlo.log %445 : tensor<9xf32>
    %447 = stablehlo.add %371, %446 : tensor<9xf32>
    %448 = stablehlo.subtract %349, %447 : tensor<9xf32>
    %449 = stablehlo.negate %345 : tensor<9xf32>
    %450 = stablehlo.select %346, %448, %449 : tensor<9xi1>, tensor<9xf32>
    %451 = stablehlo.select %330, %450, %447 : tensor<9xi1>, tensor<9xf32>
    %452 = stablehlo.select %325, %327, %451 : tensor<9xi1>, tensor<9xf32>
    %453 = stablehlo.subtract %320, %452 : tensor<9xf32>
    %454 = stablehlo.subtract %57, %453 : tensor<9xf32>
    %455 = stablehlo.exponential %454 : tensor<9xf32>
    %456 = stablehlo.multiply %34#4, %455 : tensor<9xf32>
    %457 = stablehlo.divide %456, %28 : tensor<9xf32>
    %458 = stablehlo.select %49, %51, %457 : tensor<9xi1>, tensor<9xf32>
    %459 = stablehlo.constant dense<1.000000e+00> : tensor<f32>
    %460 = stablehlo.constant dense<1.000000e+00> : tensor<9xf32>
    %461 = stablehlo.subtract %460, %458 : tensor<9xf32>
    %462 = stablehlo.select %27, %458, %461 : tensor<9xi1>, tensor<9xf32>
    return %462 : tensor<9xf32>
  }
}
